// Questa funzione tronca il valore in euro alla seconda cifra decimale
function troncaEuro (theEuro)
{
	var myNumCifreDecimali = 2;	// Numero di cifre decimali che si desidera compaiano dopo la virgola
	
	theEuro = Math.round(theEuro * Math.pow(10, myNumCifreDecimali)) / Math.pow(10, myNumCifreDecimali);
	
	return(theEuro);
}
// fine troncaEuro


// Questa funzione aggiunge in fondo al valore in euro gli necessari zeri
function aggiungiDecimali (theEuro)
{
	var myEuro = troncaEuro(theEuro);
	
	var myStr = new String(myEuro);
	var myLength = 0;
	
	myLength = myStr.length;
	
	if (myStr.lastIndexOf(".") == -1)
	{
		myStr = (myStr + ".00");
	}
	else
	{
		if ((myLength - myStr.lastIndexOf(".")) == 2)
		{
			myStr = (myStr + "0");
		}
		else if ((myLength - myStr.lastIndexOf(".")) > 3)
		{
			myLength = (myStr.lastIndexOf(".") + 3);
			myStr = myStr.substring(0, myLength);
		}
	}
	
	if (myStr.charAt(0) == ".")
	{
		myStr = ("0" + myStr);
	}
	
	return myStr;
}
// fine aggiungiDecimali


// Questa funzione seleziona il testo contenuto nel campo Importo
function selezionaImporto ()
{
	document.forms["Modulo"].Importo.select();
}
// fine selezionaImporto


// Questa funzione calcola il contributo previdenziale, l'imponibile, l'iva, il totale della fattura,
// la ritenuta d'acconto e il netto a pagare
function calcolaFattura ()
{
	// Prende i dati per effettuare i calcoli
	var myImporto = document.forms["Modulo"].Importo.value;
	var myContributoPrevidenziale = document.forms["Modulo"].ContributoPrevidenziale.value;
	var myIvaAliquota = document.forms["Modulo"].IvaAliquota.value;
	var myRitenutaAliquota = document.forms["Modulo"].RitenutaAliquota.value;
	var myTasseAliquota = document.forms["Modulo"].TasseAliquota.value;
	var myImponibile = 0;
	var myTotaleFattura = 0;
	var myImposta = 0;
	var myRitenuta = 0;
	var myNettoAPagare = 0;
	var myTasse = 0;
	var myRimanenza = 0;
	
	// Sostituisce eventuali virgole con il punto per i decimali
	myImporto = myImporto.replace(",",".");
	myContributoPrevidenziale = myContributoPrevidenziale.replace(",",".");
	myIvaAliquota = myIvaAliquota.replace(",",".");
	myRitenutaAliquota = myRitenutaAliquota.replace(",",".");
	
	// Calcola il contributo previdenziale e quindi l'imponibile
	myImponibile = ((eval(myImporto) * (1 + (eval(myContributoPrevidenziale) / 100))));
	
	// Calcola l'imposta IVA
	myImposta = (eval(myImponibile) * (eval(myIvaAliquota) / 100));
	
	// Calcola il totale della fattura
	myTotaleFattura = (eval(myImponibile) + eval(myImposta));
	
	// Calcola la ritenuta d'acconto e la sottrae al totale della fattura
	myRitenuta = (eval(myImponibile) * (eval(myRitenutaAliquota) / 100));
	
	// Calcola il netto a pagare
	myNettoAPagare = (eval(myTotaleFattura) - eval(myRitenuta));
	
	// Calcola le tasse da pagare, toglie l'iva e mostra la rimanenza a me
	myTasse = (eval(myImponibile) * (eval(myTasseAliquota) / 100));
	myRimanenza = (eval(myNettoAPagare) - eval(myImposta) - eval(myTasse));
	
	// Copia i vari calcoli negli appositi campi aggiungendo i decimali necessari
	document.forms["Modulo"].Imponibile.value = aggiungiDecimali(myImponibile);
	document.forms["Modulo"].Imposta.value = aggiungiDecimali(myImposta);
	document.forms["Modulo"].TotaleFattura.value = aggiungiDecimali(myTotaleFattura);
	document.forms["Modulo"].Ritenuta.value = aggiungiDecimali(myRitenuta);
	document.forms["Modulo"].NettoAPagare.value = aggiungiDecimali(myNettoAPagare);
	document.forms["Modulo"].Rimanenza.value = aggiungiDecimali(myRimanenza);
	
	// Seleziona il testo nel campo dell'importo, pronto per scrivere un nuovo valore
	selezionaImporto();
}
// fine calcolaFattura


// Questa funzione apre il mio sito web
function showWebSite()
{
	if (window.widget)
	{
		widget.openURL("http://www.matteovarisco.com/");
	}
	else
	{
		alert("www.matteovarisco.com");
	}
}


// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");
	
	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);

	document.getElementById('fliprollie').style.display = 'none';

}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");
	
	back.style.display="none";
	front.style.display="block";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}